コンボコントロールのドロップダウンリストでは、動的な列幅を設定することが可能です。
概要
動的な列幅を設定するには、列幅の割合を示す数値(整数、もしくは小数点第一位までの少数)とアスタリスク(*)をセットにして記述します。
例えば、それぞれの列を「* 、1.5* 、2.5* 」と設定した場合、列の横幅は可能な限り「1:1.5:2.5」の比率となるように自動調整されます。
また、動的列幅は固定幅と組み合わせることもできます。
「* 、1.5* 、100」と設定した場合、全体幅から100pxを引いた残りの部分の列幅が可能な限り「1:1.5」の比率となるように自動調整されます。
また、動的な列幅を設定すると、以下のような動作となります。
ドロップダウンリストに列の挿入/削除を行うと、動的に設定されている列幅は自動で変更され、スクロールバーは表示されない
ドロップダウンリストをドラッグして幅をリサイズすると、動的に設定されている列幅は自動で変更される
ドロップダウンリストの列幅は最小幅が設定されています。この最小幅は、表示されている列が多く、各列に割り当てられた幅が十分にないとき、列幅が小さくなりすぎないように設定されています。
なお、表示されている列の列幅の合計がドロップダウンリストの幅を超える場合はスクロールバーが表示されます。
なお、列ヘッダーの境界線をダブルクリックして列幅を自動調整したり、列幅をドラッグして幅を設定した場合に、動的な列幅は通常の列幅に変更されます。
import '@mescius/inputman/CSS/gc.inputman-js.css';
import { InputMan } from '@mescius/inputman';
import './styles.css';
InputMan.appearanceStyle = InputMan.AppearanceStyle.Modern;
var column = [
{ name: 'name', label: '製品名', width: '*' },
{ name: 'category', label: '製品カテゴリー', width: '1.5*' },
{ name: 'description', label: '製品紹介', width: '2.5*' }
];
let gcComboBox;
const update = () => {
let container = document.getElementById('container');
container.innerHTML = '';
gcComboBox = new InputMan.GcComboBox(container, {
items: [
{ name: 'ActiveReports', category: '帳票・レポート', description: '日本仕様の帳票開発に必要な機能を搭載したコンポーネント' },
{ name: 'SPREAD', category: '表計算・グリッド', description: 'Excel風のビューと表計算機能を実現するUIコンポーネント' },
{ name: 'ComponentOne', category: 'コンポーネントセット', description: 'Visual Studioで利用する.NET Framework用コンポーネント' },
{ name: 'InputMan', category: '入力支援', description: '快適な入力を実現する日本仕様入力コンポーネントセット' },
{ name: 'MultiRow', category: '多段明細', description: '1レコード複数行&日付表示に最適なグリッドコンポーネント' },
{ name: 'DioDocs', category: 'ドキュメントAPI', description: 'ドキュメントを生成、更新するAPIライブラリ' },
],
dropDownWidth: 700,
columns: column,
allowDropDownResize: true
});
}
update();
document.getElementById('addColumn').addEventListener('click', (e) => {
column.push({ name: 'sample', label: '追加列', width: '*' });
update();
});
document.getElementById('deleteColumn').addEventListener('click', (e) => {
if (column.length !== 0) {
column.pop();
update();
}
});
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>コンボコントロール - 動的列幅</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function() {
System.import('./src/app');
}
</script>
</head>
<body>
<div id="container"></div>
<table class="sample">
<tr>
<th>列の操作</th>
<td>
<button id="addColumn">列を追加する</button>
<button id="deleteColumn">列を削除する</button>
</td>
</tr>
</table>
</body>
</html>
body {
min-height: 220px;
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});

コンボコントロールのドロップダウンリストでは、動的な列幅を設定することが可能です。
概要
動的な列幅を設定するには、列幅の割合を示す数値(整数、もしくは小数点第一位までの少数)とアスタリスク(*)をセットにして記述します。
例えば、それぞれの列を「* 、1.5* 、2.5* 」と設定した場合、列の横幅は可能な限り「1:1.5:2.5」の比率となるように自動調整されます。
また、動的列幅は固定幅と組み合わせることもできます。
「* 、1.5* 、100」と設定した場合、全体幅から100pxを引いた残りの部分の列幅が可能な限り「1:1.5」の比率となるように自動調整されます。
また、動的な列幅を設定すると、以下のような動作となります。
ドロップダウンリストに列の挿入/削除を行うと、動的に設定されている列幅は自動で変更され、スクロールバーは表示されない
ドロップダウンリストをドラッグして幅をリサイズすると、動的に設定されている列幅は自動で変更される
ドロップダウンリストの列幅は最小幅が設定されています。この最小幅は、表示されている列が多く、各列に割り当てられた幅が十分にないとき、列幅が小さくなりすぎないように設定されています。
なお、表示されている列の列幅の合計がドロップダウンリストの幅を超える場合はスクロールバーが表示されます。
なお、列ヘッダーの境界線をダブルクリックして列幅を自動調整したり、列幅をドラッグして幅を設定した場合に、動的な列幅は通常の列幅に変更されます。
import { bootstrapApplication } from '@angular/platform-browser';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { InputManModule } from "@mescius/inputman.angular";
import './styles.css';
import '@mescius/inputman/CSS/gc.inputman-js.css';
import { Component, enableProdMode, ViewChild, ViewContainerRef, TemplateRef } from '@angular/core';
import GC from '@mescius/inputman';
@Component({
selector: 'app-component',
templateUrl: './src/app.component.html',
imports: [InputManModule, BrowserModule, FormsModule],
standalone: true
})
export class AppComponent {
ngOnInit(): void {
GC.InputMan.appearanceStyle = GC.InputMan.AppearanceStyle.Modern;
}
public items = [
{ name: 'ActiveReports', category: '帳票・レポート', description: '日本仕様の帳票開発に必要な機能を搭載したコンポーネント' },
{ name: 'SPREAD', category: '表計算・グリッド', description: 'Excel風のビューと表計算機能を実現するUIコンポーネント' },
{ name: 'ComponentOne', category: 'コンポーネントセット', description: 'Visual Studioで利用する.NET Framework用コンポーネント' },
{ name: 'InputMan', category: '入力支援', description: '快適な入力を実現する日本仕様入力コンポーネントセット' },
{ name: 'MultiRow', category: '多段明細', description: '1レコード複数行&日付表示に最適なグリッドコンポーネント' },
{ name: 'DioDocs', category: 'ドキュメントAPI', description: 'ドキュメントを生成、更新するAPIライブラリ' },
];
public columns = [
{ name: 'name', label: '製品名', width: '*' },
{ name: 'category', label: '製品カテゴリー', width: '1.5*' },
{ name: 'description', label: '製品紹介', width: '2.5*' }
];
@ViewChild("outlet", { read: ViewContainerRef })
public outletRef: ViewContainerRef;
@ViewChild("content", { read: TemplateRef })
public contentRef: TemplateRef<any>;
addColumn() {
this.columns.push({ name: 'sample', label: '追加列', width: '*' });
this.Render();
}
deleteColumn() {
if (this.columns.length !== 0) {
this.columns.pop();
this.Render();
}
}
private Render() {
this.outletRef.clear();
this.outletRef.createEmbeddedView(this.contentRef);
}
ngAfterViewInit() {
this.outletRef.createEmbeddedView(this.contentRef);
}
}
enableProdMode();
bootstrapApplication(AppComponent).catch(err => console.error(err));
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>コンボコントロール - 動的列幅</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
window.onload = function() {
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
}
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<ng-container #outlet>
</ng-container>
<ng-template #content>
<gc-combo-box [items]="items" [columns]="columns" [allowDropDownResize]="true"
[dropDownWidth]="700">
</gc-combo-box>
</ng-template>
<table class="sample">
<tr>
<th>列の操作</th>
<td>
<button (click)="addColumn()">列を追加する</button>
<button (click)="deleteColumn()">列を削除する</button>
</td>
</tr>
</table>
body {
min-height: 220px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
//'reflect-metadata': 'npm:reflect-metadata/Reflect.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
//'rxjs': 'npm:rxjs',
//'rxjs/operators': 'npm:rxjs/operators',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman.angular': 'npm:@mescius/inputman.angular/fesm2015/mescius-inputman.angular.mjs',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
'@mescius/inputman.richtexteditor.angular': 'npm:@mescius/inputman.richtexteditor.angular/fesm2015/mescius-inputman.richtexteditor.angular.mjs',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.richtexteditor/CSS': 'npm:@mescius/inputman.richtexteditor/CSS',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib': 'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts',
meta: {
"*.component.ts": {
loader: "system.component-loader.js"
}
}
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"@mescius/inputman": {
defaultExtension: 'js'
},
"@mescius/inputman.richtexteditor": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/inputman.angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
},
"@mescius/inputman.richtexteditor.angular": {
defaultExtension: 'mjs'
},
}
});
})(this);